package nc.bs.baiwang.bg;

package ..deTemp.1733814851355;

import java.io.IOException;
import java.util.List;
import nc.bs.framework.common.NCLocator;
import nc.bs.pub.pa.PreAlertObject;
import nc.bs.pub.taskcenter.BgWorkingContext;
import nc.bs.pub.taskcenter.IBackgroundWorkPlugin;
import nc.itf.baiwang.IBaiWangItf;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.BeanListProcessor;
import nc.jdbc.framework.processor.ResultSetProcessor;
import nc.pub.rest.util.WriteLogUtil;
import nc.tools.LoggerTools;
import nc.tools.Toolkits;
import nc.vo.pub.BusinessException;
import nc.vo.sscivm.invoice.InvoiceLedgerInfoVO;

public class SendTransInvoiceBw implements IBackgroundWorkPlugin {
  public PreAlertObject executeTask(BgWorkingContext bgContext) throws BusinessException {
    String qryInvLeg = "SELECT led.* FROM sscivm_invoice_ledgerInfo led \r\nLEFT JOIN ER_BXZB eb ON led.NC_SOURCE_BILLNO=eb.djbh \r\nLEFT JOIN er_busitem ebi ON eb.pk_jkbx = ebi.pk_jkbx and ebi.fphm=led.INVOICE_NUMBER \r\nLEFT JOIN bd_billtype bty ON eb.pk_tradetypeid = bty.pk_billtypeid \r\nLEFT JOIN bd_inoutbusiclass bi ON bi.pk_inoutbusiclass = ebi.szxmid \r\nLEFT JOIN ap_payablebill apb ON apb.billno = led.NC_SOURCE_BILLNO \r\nLEFT JOIN ap_payableitem apm ON apb.pk_payablebill = apm.pk_payablebill \r\nLEFT JOIN bd_inoutbusiclass bi2 on apm.pk_subjcode = bi2.pk_inoutbusiclass \r\nLEFT JOIN bd_billtype bty2 ON apb.pk_tradetypeid = bty2.pk_billtypeid \r\nWHERE led.transtypepk IN ( SELECT pk_billtypeid FROM bd_billtype WHERE pk_billtypecode = 'FPRZFPTZ-Cxx-001' ) \r\nAND ((eb.djbh is not null and bty.pk_billtypecode in('264X-Cxx-DGBXD','264X-Cxx-DSBXD','264X-Cxx-YFKHXD')) \r\nOR (apb.billno is not null and bty2.pk_billtypecode in('F1-Cxx-DGYF','F1-Cxx-DGYFHX','F1-Cxx-DGYTOA'))) \r\nAND nvl( led.voucher_no, '~' ) <> '~' AND nvl( led.auth_apply, 'N' ) <> 'Y' \r\nAND led.invoice_type IN ( SELECT oa_invoice_type FROM sscivm_invoice_type_map WHERE bw_lkys_invoice_type IS NOT NULL ) \r\nAND nvl( led.dr, 0 ) = 0 AND (bi.def3='false'or bi2.def3='false') \r\nAND (led.INVOICE_TYPE NOT IN('invoice003','invoice093') \r\nOR (led.INVOICE_TYPE IN('invoice003','invoice093')AND ((ebi.defitem34 like'%*运输服务*客运服务费%' OR ebi.defitem34 like'%*运输服务*国内机票款%' OR ebi.defitem34 like'%*运输服务*燃油附加费%' )  \r\nOR (apm.def29 like'%*运输服务*客运服务费%' OR apm.def29 like'%*运输服务*国内机票款%' OR apm.def29 like'%*运输服务*燃油附加费%')))) \r\nAND led.tax<>0 \r\nORDER BY led.invoice_number,TO_NUMBER( led.voucher_no )";
    List<InvoiceLedgerInfoVO> hvoList = (List<InvoiceLedgerInfoVO>)getQueryService().executeQuery(qryInvLeg, (ResultSetProcessor)new BeanListProcessor(InvoiceLedgerInfoVO.class));
    int totalCount = 0;
    int successCount = 0;
    int failCount = 0;
    if (!Toolkits.isEmpty(hvoList)) {
      totalCount = hvoList.size();
      IBaiWangItf itf = (IBaiWangItf)NCLocator.getInstance().lookup(IBaiWangItf.class);
      for (InvoiceLedgerInfoVO hvo : hvoList) {
        try {
          itf.SendTransInvoiceBw_RequiresNew(hvo);
          successCount++;
        } catch (Exception e) {
          String exstr;
          e.printStackTrace();
          failCount++;
          try {
            exstr = WriteLogUtil.getExceptionString(e);
          } catch (IOException e1) {
            e1.printStackTrace();
            exstr = "异常转字符串出错, 记录原始异常信息: " + e.getMessage();
          } 
          LoggerTools.error("任务同步记账信息到百望异常: " + exstr);
        } 
      } 
      bgContext.setLogStr("总处理记录数【" + totalCount + "】, 成功【" + successCount + "】, 失败【" + failCount + "】");
    } else {
      bgContext.setLogStr("无符合条件的台账记录");
    } 
    return null;
  }
  
  public IUAPQueryBS getQueryService() {
    return (IUAPQueryBS)NCLocator.getInstance().lookup(IUAPQueryBS.class);
  }
}
